<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: step_template.xsl,v 1.4 2010-10-08 17:48:49 hz0wyg Exp $ -->

<xsl:stylesheet version='1.0'
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
	xmlns:xmi='http://www.omg.org/XMI'
	xmlns:sysML='http://www.topcased.org/1.0/sysML'
	xmlns:uml='http://www.eclipse.org/uml2/2.1.0/UML'
	exclude-result-prefixes='xsl xmi sysML uml'>
	
	<xsl:output method="text"/>
	<xsl:key name="ids_by_pos" match="/*[@xmi:id]" use="position()"/>
	
	<xsl:template name="step-header">
		<xsl:param name="day"/>
		<xsl:param name="month"/>
		<xsl:param name="year"/>
		<xsl:param name="hour"/>
		<xsl:param name="minute"/>
		<xsl:param name="second"/>
		<xsl:param name="tzoffset_direction"/>
		<xsl:param name="tzoffset_hours"/>
		<xsl:param name="filename"/>
		<xsl:param name="author-lastname"/>
		<xsl:param name="author-firstname"/>
		<xsl:param name="organization"/>
		
ISO-10303-21;
HEADER;
/* Extracted from Topcased SysML Model in XMI */

FILE_DESCRIPTION(
/* description */ (' AP233 Extraction from <xsl:value-of select='$filename'/>'),
/* implementation_level */ '2;1');

FILE_NAME(
/* name */ '<xsl:value-of select='$filename'/>',
/* time_stamp */ '<xsl:value-of select="concat($year,'-',$month,'-',$day,'T',$hour,':',$minute,':',$second,$tzoffset_direction,$tzoffset_hours)"/>',
/* author */ ('<xsl:value-of select="concat($author-firstname,' ',$author-lastname)"/>'),
/* organization */ ('<xsl:value-of select='$organization'/>'),
/* preprocessor_version */ '$Revision: 1.4 $',
/* originating_system */ '$RCSfile: step_template.xsl,v $',
/* authorisation */ '');

FILE_SCHEMA (('AP233_SYSTEMS_ENGINEERING_ARM_LF'));
ENDSEC;

DATA;
#1=VIEW_DEFINITION_CONTEXT('Requirements_Analysis_Process','Concept_stage','');
#10=PERSON('<xsl:value-of select="$author-lastname"/>','<xsl:value-of select="$author-firstname"/>',(''),(''),(''));
#12=ORGANIZATION('<xsl:value-of select='$organization'/>','<xsl:value-of select='$organization'/>');
#14=ADDRESS('Office','30001','Van Dyke, Bldgs 2-10','PO Box 9020','Warren','Michigan','48090-9020','USA','480-210-525','+1.586.492.4539','+1.586.623.9139','michael.loeffler@gm.com','','http://www.gm.com');
#16=PERSON_IN_ORGANIZATION(#10,#12,'Global App Architect for Electrical, Controls and Software');
#18=ADDRESS_ASSIGNMENT('Work',#14,(#16));
#20=ACTIVITY_METHOD('XSLT_Extract','XSLT Extract of STEP Part 21 Data File from Topcased SysML XMI','','For initial creation of dataset');
#22=ACTIVITY('SysML_Extract','Extract from SysML XMI','Extracted from Topcased SysML Model in XMI',#20);
#24=CALENDAR_DATE(<xsl:value-of select='$year'/>,<xsl:value-of select='$month'/>,<xsl:value-of select='$day'/>);
#26=LOCAL_TIME(<xsl:value-of select='$hour'/>,<xsl:value-of select='$minute'/>,<xsl:value-of select='$second'/>,#32);
#28=DATE_TIME(#24,#26);
#30=DATE_OR_DATE_TIME_ASSIGNMENT(#28,'Creation date and time',(#22));
#32=TIME_OFFSET(<xsl:value-of select='$tzoffset_hours'/>,$,.BEHIND.);
#34=EXTERNAL_CLASS_LIBRARY('http://www.ap233.org/ap233-public-information/ap233-reference-data/ap233_basic_library','Library of basic concept values from AP233');
#36=EXTERNAL_CLASS('http://www.omg.org/spec/SysML/Current/SysML-profile#DeriveReqt','DeriveReqt','The "derive requirement" relationship relates a derived requirement to its source requirement.',#34);
#38=EXTERNAL_CLASS('http://www.omg.org/spec/SysML/Current/SysML-profile#Refine','Refine','The refine requirement relationship can be used to describe how a model element or set of elements can be used to further refine a requirement.',#34);
#40=EXTERNAL_CLASS('http://www.omg.org/spec/SysML/Current/SysML-profile#Satisfy','Satisfy','The satisfy relationship describes how a design or implementation model satisfies one or more requirements.',#34);
#42=EXTERNAL_CLASS('http://www.omg.org/spec/SysML/Current/SysML-profile#Verify','Verify','The verify relationship defines how a test case or other model element verifies a requirement.',#34);
	</xsl:template>

	<xsl:template name="step-footer">
ENDSEC;
END-ISO-10303-21;
	</xsl:template>
	
	<xsl:template name="step-xmi-id">
		<xsl:param name="xmi_id"/>
		<xsl:for-each select="//*[@xmi:id]">
			<xsl:if test="@xmi:id=$xmi_id">
				<xsl:value-of select="position()*100"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

</xsl:stylesheet>
