<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: block_template.xsl,v 1.5 2010/10/14 17:57:14 hz0wyg Exp $ -->

<xsl:stylesheet version='1.0'
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
	xmlns:xmi='http://www.omg.org/XMI'
	xmlns:sysML='http://www.topcased.org/1.0/sysML'
	xmlns:ConfigurationProfile='http:///schemas/ConfigurationProfile/_DzOpgNMHEd-zD4zFaippQA/5'
	exclude-result-prefixes='xsl xmi sysML ConfigurationProfile'>
	
	<xsl:output method="text"/>
<!--	<xsl:include href="step_template.xsl"/>   Included by caller -->
	
	
	<xsl:template name="block">
		<xsl:variable name="this_id" select="@xmi:id"/>
		<xsl:variable name="parent_id" select="../@xmi:id"/>
		<xsl:variable name="name" select="@name"/>
		<xsl:variable name="apos">'</xsl:variable>
		<xsl:variable name="version" select="./ownedAttribute[@name='version']/defaultValue/@value"/>
		<xsl:variable name="version_offset" select="10"/>
		<xsl:variable name="version_seq_offset" select="12"/>
		<xsl:variable name="version_deriv_offset" select="14"/>
		<xsl:variable name="version_hier_offset" select="16"/>
		<xsl:variable name="view_definition_offset" select="20"/>		
		<xsl:variable name="usage_offset" select="30"/>
		<xsl:variable name="quantity_offset" select="40"/>
		<xsl:variable name="xmi_id">
			<xsl:call-template name="step-xmi-id">
				<xsl:with-param name="xmi_id" select="@xmi:id"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="parent_xmi_id">
			<xsl:call-template name="step-xmi-id">
				<xsl:with-param name="xmi_id" select="../@xmi:id"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="parent_type" select="../@xmi:type"/>
		<xsl:variable name="system_block" select="//nestedClassifier[@xmi:type='sysML:Block']/ownedAttribute[@xmi:type='uml:Property' and @name='system']/../@xmi:id"/>
		<xsl:variable name="quantity" select="//nestedClassifier[@xmi:id=$parent_id]/ownedAttribute[@type=$this_id]/lowerValue/@value"/>
			
<!--

#920=SYSTEM('HSUV','HSUVSystem','Hybrid Sport Utility Vehicle System');
#930=SYSTEM_VERSION('HSUV-1','HSUVSystem version',#920);
#940=SYSTEM_VIEW_DEFINITION('HSUV-1','HSUVSystem view definition','',#40,(),#930);
#950=SYSTEM_BREAKDOWN('HSUV','HybridSUV Breakdown','Hybrid Sport Utility Vehicle System breakdown');
#960=SYSTEM_BREAKDOWN_VERSION('HSUV-1-Breakdown','HybridSUV breakdown version',#950);
#970=BREAKDOWN_OF('HSUV-Breakdown-of','HSUV-1-Breakdown-of','Breakdown of HSUVSystem',#960,#940);
#980=SYSTEM_ELEMENT('HSUV-Element','HSUVSystem','Hybrid Sport Utility Vehicle System element');
#990=SYSTEM_ELEMENT_VERSION('1','HSUVSystem element version',#980);
#1000=SYSTEM_ELEMENT_DEFINITION('HSUV-1','HSUVSystem element definition','',#40,(),#990);
#1010=SYSTEM_ELEMENT('p','PowerSubsystem','PowerSubsystem');
#1020=SYSTEM_ELEMENT_VERSION('1','PowerSubsystem version',#1010);
#1030=SYSTEM_ELEMENT_DEFINITION('p-1','PowerSubsystem element definition','',#40,(),#1020);
#1040=SYSTEM_ELEMENT_USAGE('HSUV->p','','PowerSubsystem of HSUV',#1000,#1030);
#1330=SYSTEM_BREAKDOWN_CONTEXT('HSUV-Context','HSUV-Context','HSUV System Breakdown Context to top System Element',#960,#1000);

-->
		<xsl:value-of select="concat('#',$xmi_id,'=SYSTEM(',$apos,$xmi_id,$apos,',',$apos,$name,$apos,',',$apos,$name,' System',$apos,');')"/>
		<xsl:text>
		</xsl:text>
		<xsl:value-of select="concat('#',$xmi_id+$version_offset,'=SYSTEM_VERSION(',$apos,$version,$apos,',',$apos,$name,' System Element Version',$apos,',','#',$xmi_id,');')"/>
		<xsl:text>
		</xsl:text>
		<xsl:for-each select="//packagedElement[@xmi:type='uml:Dependency' and @name='sequence' and @supplier=$this_id]">
			<xsl:variable name="preceding_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="concat('#',$xmi_id+$version_seq_offset,'=PRODUCT_VERSION_RELATIONSHIP(',$apos,'sequence',$apos,',',$apos,'Version Sequence',$apos,',#',$preceding_id+$version_offset,',#',$xmi_id+$version_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
		<xsl:for-each select="//packagedElement[@xmi:type='uml:Dependency' and @name='derivation' and @supplier=$this_id]">
			<xsl:variable name="based_on_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="concat('#',$xmi_id+$version_deriv_offset,'=PRODUCT_VERSION_RELATIONSHIP(',$apos,'derivation',$apos,',',$apos,'Version Derivation',$apos,',#',$based_on_id+$version_offset,',#',$xmi_id+$version_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
		<xsl:for-each select="//packagedElement[@xmi:type='uml:Dependency' and @name='hierarchy' and @supplier=$this_id]">
			<xsl:variable name="ordinate_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="concat('#',$xmi_id+$version_hier_offset,'=PRODUCT_VERSION_RELATIONSHIP(',$apos,'sequence',$apos,',',$apos,'Version Hierarchy',$apos,',#',$ordinate_id+$version_offset,',#',$xmi_id+$version_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
		<xsl:value-of select="concat(
								'#',$xmi_id+$view_definition_offset,'=SYSTEM_VIEW_DEFINITION(',
									$apos,$version,$apos,',',
									$apos,$name,' System View Definition',$apos,',',
									$apos,$apos,',',
									'#1',',',
									'(),',
									'#',$xmi_id+$version_offset,
								');'
							)"/>
		<xsl:text>
		</xsl:text>
		<xsl:if test="not(@xmi:id=$system_block)">
			<xsl:value-of select="concat(
								'#',$xmi_id+$usage_offset,'=NEXT_ASSEMBLY_USAGE(',
									'#',$parent_xmi_id+$view_definition_offset,',',
									'#',$xmi_id+$view_definition_offset,',',
									$apos,$apos,',',
									'#',$xmi_id+$quantity_offset,
								');'
							)"/>
			<xsl:text>
			</xsl:text>
		</xsl:if>
		<xsl:if test="$quantity &gt; 0"><xsl:value-of select="concat('#',$xmi_id+$quantity_offset,'=VALUE_WITH_UNIT(#2,',$quantity,');')"/></xsl:if>
		<xsl:if test="string-length($quantity) = 0"><xsl:value-of select="concat('#',$xmi_id+$quantity_offset,'=VALUE_WITH_UNIT(#2,1);')"/></xsl:if>
		<xsl:text>
		</xsl:text>

		<xsl:call-template name="block-constituent-rows"></xsl:call-template>
	</xsl:template>
	
	<xsl:template name="block-constituent-rows">
		<xsl:for-each select="./nestedClassifier[@xmi:type='sysML:Block']">
			<xsl:call-template name="block"/>
		</xsl:for-each>
	</xsl:template>
	
</xsl:stylesheet>
