<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: requirement_template.xsl,v 1.6 2010-10-14 17:57:14 hz0wyg Exp $ -->

<xsl:stylesheet version='1.0'
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
	xmlns:xmi='http://www.omg.org/XMI'
	xmlns:sysML='http://www.topcased.org/1.0/sysML'
	xmlns:uml='http://www.eclipse.org/uml2/2.1.0/UML'
	exclude-result-prefixes='xsl xmi sysML uml'>
	
	<xsl:output method="text"/>
<!--	<xsl:include href="step_template.xsl"/>   Included by caller -->
	<xsl:include href="rationale_rows_template.xsl"/>
	<xsl:include href="problem_rows_template.xsl"/>
	<xsl:include href="gencomment_rows_template.xsl"/>
	
	
	<xsl:template name="requirement">
		<xsl:variable name="this_id" select="@xmi:id"/>
		<xsl:variable name="source" select="@source"/>
		<xsl:variable name="kind" select="@kind"/>
		<xsl:variable name="risk" select="@risk"/>
		<xsl:variable name="verifyMethod" select="@verifyMethod"/>
		<xsl:variable name="priority" select="./extendedField[@name='Priority']/@value"/>
		<xsl:variable name="name" select="@name"/>
		<xsl:variable name="req_id" select="@id"/>
		<xsl:variable name="text" select="@text"/>
		<xsl:variable name="apos">'</xsl:variable>
		<xsl:variable name="version" select="substring-after(./ownedAttribute[@name='version']/eAnnotations/details/@value,'version=')"/>
		<xsl:variable name="version_offset" select="10"/>
		<xsl:variable name="version_seq_offset" select="12"/>
		<xsl:variable name="version_deriv_offset" select="14"/>
		<xsl:variable name="version_hier_offset" select="16"/>
		<xsl:variable name="view_definition_offset" select="20"/>		
		<xsl:variable name="collection_relationship_offset" select="30"/>		
		<xsl:variable name="xmi_id">
			<xsl:call-template name="step-xmi-id">
				<xsl:with-param name="xmi_id" select="@xmi:id"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="parent_xmi_id">
			<xsl:call-template name="step-xmi-id">
				<xsl:with-param name="xmi_id" select="../@xmi:id"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="parent_type" select="../@xmi:type"/>
			
<!--			Priority:-->
<!--				<xsl:if test="string-length($priority) = 0">Low (Default)</xsl:if>-->
<!--				<xsl:if test="string-length($priority) > 0"><xsl:value-of select="$priority"/></xsl:if>-->
<!---->
<!--			Source:-->
<!--				<xsl:if test="string-length($source) = 0">Undefined</xsl:if>-->
<!--				<xsl:if test="string-length($source) > 0"><xsl:value-of select="$source"/></xsl:if>-->
<!---->
<!--			Kind:-->
<!--				<xsl:if test="string-length($kind) = 0">Functional</xsl:if>-->
<!--				<xsl:if test="string-length($kind) > 0"><xsl:value-of select="$kind"/></xsl:if>-->
<!---->
<!--			Risk:-->
<!--				<xsl:if test="string-length($risk) = 0">High</xsl:if>-->
<!--				<xsl:if test="string-length($risk) > 0"><xsl:value-of select="$risk"/></xsl:if>-->
<!---->
<!--			Verify Method:-->
<!--				<xsl:if test="string-length($verifyMethod) = 0">Analysis</xsl:if>-->
<!--				<xsl:if test="string-length($verifyMethod) > 0"><xsl:value-of select="$verifyMethod"/></xsl:if>-->

<!--

#10=REQUIREMENT('R1.0','HSUVSpecification','Test of HSUV Specification instantiation');
#20=REQUIREMENT_VERSION('1','HSUVSpecification version',#10);
#30=REQUIREMENT_VIEW_DEFINITION('1','HSUVSpecification View Definition','',#40,(),#20);
#40=VIEW_DEFINITION_CONTEXT('Requirements_Analysis_Process','Concept_stage','');
#50=REQUIREMENT('R1.2','Eco-Friendliness','Eco-Friendliness');
#60=REQUIREMENT_VERSION('1','Eco-Friendliness version',#50);
#70=REQUIREMENT_VIEW_DEFINITION('1','Eco-Friendliness View Definition','',#40,(),#60);
#80=REQUIREMENT_COLLECTION_RELATIONSHIP('R1.0-2','isComposedOf','Points to member requirement of HSUVSpecification',#30,#70);

-->
		<xsl:value-of select="concat('#',$xmi_id,'=REQUIREMENT(',$apos,$req_id,$apos,',',$apos,$name,$apos,',',$apos,$name,' Requirement',$apos,');')"/>
		<xsl:text>
		</xsl:text>
		<xsl:value-of select="concat('#',$xmi_id+$version_offset,'=REQUIREMENT_VERSION(',$apos,$version,$apos,',',$apos,$text,$apos,',','#',$xmi_id,');')"/>
		<xsl:text>
		</xsl:text>
		<xsl:for-each select="//packagedElement[@xmi:type='uml:Dependency' and @name='sequence' and @supplier=$this_id]">
			<xsl:variable name="preceding_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="concat('#',$xmi_id+$version_seq_offset,'=PRODUCT_VERSION_RELATIONSHIP(',$apos,'sequence',$apos,',',$apos,'Version Sequence',$apos,',#',$preceding_id+$version_offset,',#',$xmi_id+$version_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
		<xsl:for-each select="//packagedElement[@xmi:type='uml:Dependency' and @name='derivation' and @supplier=$this_id]">
			<xsl:variable name="based_on_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="concat('#',$xmi_id+$version_deriv_offset,'=PRODUCT_VERSION_RELATIONSHIP(',$apos,'derivation',$apos,',',$apos,'Version Derivation',$apos,',#',$based_on_id+$version_offset,',#',$xmi_id+$version_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
		<xsl:for-each select="//packagedElement[@xmi:type='uml:Dependency' and @name='hierarchy' and @supplier=$this_id]">
			<xsl:variable name="ordinate_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="concat('#',$xmi_id+$version_hier_offset,'=PRODUCT_VERSION_RELATIONSHIP(',$apos,'sequence',$apos,',',$apos,'Version Hierarchy',$apos,',#',$ordinate_id+$version_offset,',#',$xmi_id+$version_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
		<xsl:value-of select="concat(
								'#',$xmi_id+$view_definition_offset,'=REQUIREMENT_VIEW_DEFINITION(',
									$apos,$version,$apos,',',
									$apos,$name,' Requirement View Definition',$apos,',',
									$apos,$apos,',',
									'#1',',',
									'(),',
									'#',$xmi_id+$version_offset,
								');'
							)"/>
		<xsl:text>
		</xsl:text>
		<xsl:if test="$parent_type='sysML:Requirement'">
			<xsl:value-of select="concat(
								'#',$xmi_id+$collection_relationship_offset,'=REQUIREMENT_COLLECTION_RELATIONSHIP(',
									$apos,$apos,',',
									$apos,'isComposedOf',$apos,',',
									$apos,$apos,',',
									'#',$parent_xmi_id+$view_definition_offset,',',
									'#',$xmi_id+$view_definition_offset,
								');'
							)"/>
			<xsl:text>
			</xsl:text>
		</xsl:if>
			

<!--			<xsl:call-template name="rationale-rows"><xsl:with-param name="element_id" select="@xmi:id"/></xsl:call-template>-->
<!--			<xsl:call-template name="testcase-rows"><xsl:with-param name="req_id" select="@xmi:id"/></xsl:call-template>-->
<!--			<xsl:call-template name="problem-rows"><xsl:with-param name="element_id" select="@xmi:id"/></xsl:call-template>-->
<!--			<xsl:call-template name="gencomment-rows"><xsl:with-param name="element_id" select="@xmi:id"/></xsl:call-template>-->
		<xsl:call-template name="req-constituent-rows"></xsl:call-template>
<!--			<xsl:call-template name="refinedby-rows"><xsl:with-param name="req_id" select="@xmi:id"/></xsl:call-template>-->
	</xsl:template>
	
	<xsl:template name="testcase-rows">
		<xsl:param name="req_id"/>
		<xsl:for-each select="//ownedTraceDependency[@supplier=$req_id and @xmi:type='sysML:Verify']">
			<xsl:variable name="client_id" select="@client"/>
			<xsl:for-each select="//packagedElement[@xmi:id=$client_id and @xmi:type='sysML:TestCase']">

				Test Case:
				<xsl:value-of select="@name"/>

				Test Result:
				<xsl:if test="string-length(@result) = 0">Pass</xsl:if>
				<xsl:if test="string-length(@result) > 0"><xsl:value-of select="@result"/></xsl:if>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>

<!--#790=REQUIREMENT_VIEW_DEFINITION_RELATIONSHIP('R2.0->R1.1.1','DeriveReqt','Derive RegenerativeBraking requirement from Braking requirement',#310,#630);-->

	<xsl:template name="derived-requirement">
		<xsl:for-each select="//packagedElement[@xmi:type='sysML:DeriveReqt']">
			<xsl:variable name="apos">'</xsl:variable>
			<xsl:variable name="name" select="@name"/>
			<xsl:variable name="client">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="supplier">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@supplier"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="xmi_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@xmi:id"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="view_definition_offset" select="20"/>		
			<xsl:value-of select="concat('#',$xmi_id,'=REQUIREMENT_VIEW_DEFINITION_RELATIONSHIP(',$apos,$xmi_id,$apos,',',$apos,'DeriveReqt',$apos,',',$apos,$name,$apos,',#',$supplier+$view_definition_offset,',','#',$client+$view_definition_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
<!--#880=CLASSIFICATION_ASSIGNMENT(#780,(#790,#800,#810,#820,#830,#840,#850,#860,#870),'DeriveReqt');-->
#50=CLASSIFICATION_ASSIGNMENT(#36,(<xsl:for-each select="//packagedElement[@xmi:type='sysML:DeriveReqt']">
			<xsl:variable name="xmi_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@xmi:id"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="view_definition_offset" select="20"/>		
			<xsl:value-of select="concat('#',$xmi_id)"/>
			<xsl:if test="position()!=last()">,</xsl:if>
		</xsl:for-each>),'DeriveReqt');
	</xsl:template>
	
	<xsl:template name="refine-requirement">
		<xsl:for-each select="//packagedElement[@xmi:type='sysML:Refine']">
			<xsl:variable name="apos">'</xsl:variable>
			<xsl:variable name="name" select="@name"/>
			<xsl:variable name="client">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="supplier">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@supplier"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="xmi_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@xmi:id"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="view_definition_offset" select="20"/>		
			<xsl:value-of select="concat('#',$xmi_id,'=REQUIREMENT_VIEW_DEFINITION_RELATIONSHIP(',$apos,$xmi_id,$apos,',',$apos,'Refine',$apos,',',$apos,$name,$apos,',#',$supplier+$view_definition_offset,',','#',$client+$view_definition_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
#52=CLASSIFICATION_ASSIGNMENT(#38,(<xsl:for-each select="//packagedElement[@xmi:type='sysML:Refine']">
			<xsl:variable name="xmi_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@xmi:id"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="view_definition_offset" select="20"/>		
			<xsl:value-of select="concat('#',$xmi_id)"/>
			<xsl:if test="position()!=last()">,</xsl:if>
		</xsl:for-each>),'Refine');
	</xsl:template>
	
	<xsl:template name="satisfy-requirement">
		<xsl:for-each select="//packagedElement[@xmi:type='sysML:Satisfy']">
			<xsl:variable name="apos">'</xsl:variable>
			<xsl:variable name="name" select="@name"/>
			<xsl:variable name="client">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@client"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="supplier">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@supplier"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="xmi_id">
				<xsl:call-template name="step-xmi-id">
					<xsl:with-param name="xmi_id" select="@xmi:id"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="view_definition_offset" select="20"/>		
			<xsl:value-of select="concat('#',$xmi_id,'=REQUIREMENT_ASSIGNMENT(',$apos,$xmi_id,$apos,',',$apos,$name,$apos,',#',$supplier+$view_definition_offset,',#',$client+$view_definition_offset,');')"/>
			<xsl:text>
			</xsl:text>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="req-constituent-rows">
		<xsl:for-each select="./nestedClassifier[@xmi:type='sysML:Requirement']">
			<xsl:call-template name="requirement"/>
		</xsl:for-each>
	</xsl:template>
	
</xsl:stylesheet>
